<script>
    import {
        geoEqualEarth,
        geoNaturalEarth1,
        geoOrthographic,
        geoGraticule10,
        geoPath,
    } from "d3-geo";
    import { json } from "d3-fetch";
    import * as topojson from "topojson-client";

    // Props passed from the calling component
    export let plot_element;
    export let data;
    export let xScale;
    export let yScale;
    export let subplot;
    // Prepare Projection.
    $: width = xScale.range()[1] - xScale.range()[0];
    $: height = yScale.range()[0] - yScale.range()[1];
    $: xmid = xScale.range()[0] + 0.5 * width;
    $: ymid = yScale.range()[0] - 0.5 * height;
    $: projection = geoNaturalEarth1()
        .translate([xmid, ymid])
        .scale(Math.min(height / 3, width / 6));
    $: console.log(width, height);
    // $: console.log(xScale.range(), yScale.range());
    // $: projection = projection.fitExtent(
    //     [
    //         [xScale.range()[0], xScale.range()[1]],
    //         [yScale.range()[0], yScale.range()[1]],
    //     ],
    //     {
    //         type: "Sphere",
    //     },
    // );
    // Many other projections are available.
    // See them here: https://github.com/d3/d3-geo#projections.

    const json_rect = {
        type: "FeatureCollection",
        features: [
            {
                type: "Feature",
                properties: {},
                geometry: {
                    type: "Polygon",
                    coordinates: [
                        [
                            [-40, -30],
                            [-90, -30],
                            [-90, 15],
                            [-40, 15],
                            [-40, -30],
                        ],
                    ],
                },
            },
        ],
    };
    // Prepare Graticule: a grid of meridians and parallels
    // for showing projection distortion.
    const graticule = geoGraticule10();

    // Prepare Path-Generator: given a GeoJSON geometry or
    // feature object, it generates an SVG path data string.
    $: path = geoPath(projection);

    // Prepare the outline (see https://github.com/d3/d3-geo#_path).
    // "The type Sphere is also supported, which is useful for
    // rendering the outline of the globe; a sphere has no coordinates."
    let outline = { type: "Sphere" };

    // Prepare variables for data to load in.
    let land, borders;

    json(
        // Load the geo-data from npm.
        // More info here: https://github.com/topojson/world-atlas.
        // And here: https://www.npmjs.com/package/world-atlas.
        "https://cdn.jsdelivr.net/npm/world-atlas@2/countries-50m.json",
    ).then((world) => {
        // then pull out the land-shapes
        land = topojson.feature(world, world.objects.land);
        // and border-shapes
        borders = topojson.mesh(
            world,
            world.objects.countries,
            (a, b) => a !== b,
        );
    });
</script>

<g>
    <path d={path(outline)} fill="lightgrey" stroke="none" />
    <path d={path(graticule)} stroke="#aaa" fill="none" />
    <path d={path(land)} fill="gray" />
    <path d={path(borders)} fill="none" stroke="lightgrey" stroke-width="1px" />
    <path
        d={path(json_rect)}
        fill="red"
        fill-opacity="50%"
        stroke="red"
        stroke-width="1px" />
    <path d={path(outline)} fill="none" stroke="#000" stroke-width="3px" />
</g>
